datablock WheeledVehicleData(HydricVehicle)
{
   isCustom=1;
   type="Hydric";
	uiName = "Hydric";
	
	shapeFile = "./Hydric.dts";
	category = "Vehicles";
	displayName = " ";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0.2 0.9";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.8;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	//tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 9;         // Far distance from vehicle
	cameraOffset = 4.2;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.3;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= HydricTire;
	defaultSpring	= HydricSpring;
	flatTire	= jeepFlatTire;
	flatSpring	= jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 4.5;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;


	// Engine
	engineTorque = 2500;	//teneksi	3000; //4000;       // Engine power
	engineBrake = 250;	//teneksi	700;         // Braking when throttle is 0
	brakeTorque = 2500;	//teneksi	3200;        // When brakes are applied
	maxWheelSpeed = 53;	//teneksi	42;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0;

	// Advanced Steering
  	steeringAutoReturn = true;
  	steeringAutoReturnRate = 1;
  	steeringAutoReturnMaxSpeed = 10;
 	steeringUseStrafeSteering = true;
 	steeringStrafeSteeringRate = 0.08;
	
	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = jeepSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = VehicleFoamDropletsEmitter;
	splashEmitter[1] = VehicleFoamEmitter;
	splashEmitter[2] = VehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = SlowImpactSound;
	hardImpactSound = FastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   handsOnVehicle = 1;

   numDmgEmitterAreas = 1;


   initialExplosionProjectile = HydricExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = HydricFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};
Garage_AddParts("add-ons/Vehicle_Hydric/Hydric.txt");

function HydricVehicle::onAdd(%this,%obj)
{
   Parent::onAdd(%this,%obj);
   HydricSpeedCheck(%this, %obj);
   %obj.playthread(0,"propslow");
 %obj.hideNode(lhand);
 %obj.hideNode(rhand);
 %obj.hideNode(lhook);
 %obj.hideNode(rhook);
 %obj.schedule(0,garageDefault);

 %obj.setWheelPowered(0, true);			//teneksi
 %obj.setWheelPowered(1, true );		//teneksi
 %obj.setWheelPowered(2, false );		//teneksi
 %obj.setWheelPowered(3, false );		//teneksi
}

function HydricSpeedCheck(%this, %obj)
{


	if(!isObject(%obj))
		return;

	%vehicle = %obj;


	%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());
	if(!%vehicle.oldSpeed)
	    %vehicle.oldSpeed = %speed;

	//Braking is not working currently
	if(%vehicle.oldSpeed)
	{
		if((%vehicle.oldSpeed - %speed) > 2) //Braking rate of speed in 500MS
			%applyBrakes = true;

		if(%speed < 1)
			%applyBrakes = false;
	}

	if(%speed < 0) //Keeps throwing random negative numbers when Hydric is at dead stop
	    %speed = 0;

	%vehicle.oldSpeed = %speed;
	commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed * 2) @"<color:FFFF00>BPS", 1);




	//We use else if's so that it will find a true statement then skip the rest
	if(%speed < 2) {
		%vehicle.stopThread(0);
		%vehicle.playAudio(0,"HydricIdle");
	    }

	else if(%speed < 15) {
	    %vehicle.playAudio(%slot, HydricSpeed1);
	    }

	else if(%speed < 25)
	    %vehicle.playAudio(%slot, HydricSpeed2);

	else if(%speed < 35)
	    %vehicle.playAudio(%slot, HydricSpeed3);


	else if(%speed < 45)
	    %vehicle.playAudio(%slot, HydricSpeed4);

	else if(%speed < 50) {
	    %vehicle.stopThread(0);
	    %vehicle.playAudio(%slot, HydricSpeed5);
	    }

	if(%applyBrakes)
		%vehicle.playAudio(1, HydricDrift);
	if(!%applyBrakes)
		%vehicle.stopAudio(1);

	schedule(500,0,"HydricSpeedCheck",%this,%obj);
}

package HydricMountSound
{
	function armor::onMount(%this,%obj,%col,%slot)
	{
		if(%col.dataBlock !$= "HydricVehicle")
		{
			parent::onMount(%this,%obj,%col,%slot);
			%obj.canDismount = true;
		}
		if(%col.dataBlock $= "HydricVehicle")
		{
			parent::onMount(%this,%obj,%col,%slot);

			serverplay3d("HydricMount" @ getRandom(1, 3), %obj.getHackPosition());
		}
	}
};

activatePackage(HydricMountSound);